1 # git-mergetool--lib is a shell library for common merge tool functions
3 : ${MERGE_TOOLS_DIR=$(git --exec-path)/mergetools}
18 merge_tool_path
=$
(translate_merge_tool_path
"$1") &&
19 type "$merge_tool_path" >/dev
/null
2>&1
22 list_config_tools
() {
26 git config
--get-regexp $section'\..*\.cmd' |
27 while read -r key value
29 toolname
=${key#$section.}
30 toolname
=${toolname%.cmd}
32 printf "%s%s\n" "$line_prefix" "$toolname"
37 condition
=${1:-true} per_line_prefix=${2:-} preamble=${3:-}
42 ( cd "$MERGE_TOOLS_DIR" && ls ) |
{
45 if setup_tool
"$toolname" 2>/dev
/null
&&
46 (eval "$condition" "$toolname")
48 if test -n "$preamble"
50 printf "%s\n" "$preamble"
54 printf "%s%s\n" "$per_line_prefix" "$toolname"
58 if test -n "$extra_content"
60 if test -n "$preamble"
62 # Note: no '\n' here since we don't want a
63 # blank line if there is no initial content.
64 printf "%s" "$preamble"
68 printf "\n%s\n" "$extra_content"
71 if test -n "$preamble" && test -n "$not_found_msg"
73 printf "%s\n" "$not_found_msg"
81 test "$TOOL_MODE" = diff
85 test "$TOOL_MODE" = merge
88 translate_merge_tool_path
() {
93 if test "$MERGED" -nt "$BACKUP"
99 echo "$MERGED seems unchanged."
100 printf "Was the merge successful? [y/n] "
101 read answer ||
return 1
111 setup_tool
"$1" && return 0
112 cmd
=$
(get_merge_tool_cmd
"$1")
117 merge_tool_cmd
=$
(get_merge_tool_cmd
"$tool")
118 test -n "$merge_tool_cmd" ||
return 1
121 ( eval $merge_tool_cmd )
125 trust_exit_code
=$
(git config
--bool \
126 "mergetool.$1.trustExitCode" ||
echo false
)
127 if test "$trust_exit_code" = "false"
130 ( eval $merge_tool_cmd )
133 ( eval $merge_tool_cmd )
141 # Fallback definitions, to be overridden by tools.
158 translate_merge_tool_path
() {
162 if ! test -f "$MERGE_TOOLS_DIR/$tool"
168 # Load the redefined functions
169 .
"$MERGE_TOOLS_DIR/$tool"
170 # Now let the user override the default command for the tool. If
171 # they have not done so then this will return 1 which we ignore.
174 if merge_mode
&& ! can_merge
176 echo "error: '$tool' can not be used to resolve merges" >&2
178 elif diff_mode
&& ! can_diff
180 echo "error: '$tool' can only be used to resolve merges" >&2
186 get_merge_tool_cmd
() {
190 git config
"difftool.$merge_tool.cmd" ||
191 git config
"mergetool.$merge_tool.cmd"
193 git config
"mergetool.$merge_tool.cmd"
197 # Entry point for running tools
199 # If GIT_PREFIX is empty then we cannot use it in tools
200 # that expect to be able to chdir() to its value.
201 GIT_PREFIX
=${GIT_PREFIX:-.}
204 merge_tool_path
=$
(get_merge_tool_path
"$1") ||
exit
207 # Bring tool-specific functions into scope
208 setup_tool
"$1" ||
return 1
218 # Run a either a configured or built-in diff tool
223 # Run a either a configured or built-in merge tool
228 list_merge_tool_candidates
() {
231 tools
="tortoisemerge"
235 if test -n "$DISPLAY"
237 if test -n "$GNOME_DESKTOP_SESSION_ID"
239 tools
="meld opendiff kdiff3 tkdiff xxdiff $tools"
241 tools
="opendiff kdiff3 tkdiff xxdiff meld $tools"
243 tools
="$tools gvimdiff diffuse diffmerge ecmerge"
244 tools
="$tools p4merge araxis bc codecompare"
246 case "${VISUAL:-$EDITOR}" in
248 tools
="$tools vimdiff emerge"
251 tools
="$tools emerge vimdiff"
257 tool_opt
="'git ${TOOL_MODE}tool --tool=<tool>'"
264 cmd_name
=${TOOL_MODE}tool
266 diff_mode
&& list_config_tools difftool
"$tab$tab"
267 list_config_tools mergetool
"$tab$tab"
270 if test -n "$config_tools"
272 extra_content
="${tab}user-defined:${LF}$config_tools"
275 show_tool_names
'mode_ok && is_available' "$tab$tab" \
276 "$tool_opt may be set to one of the following:" \
277 "No suitable tool for 'git $cmd_name --tool=<tool>' found." \
281 show_tool_names
'mode_ok && ! is_available' "$tab$tab" \
282 "${LF}The following tools are valid, but not currently available:" &&
285 if test "$any_shown" = yes
288 echo "Some of the tools listed above only work in a windowed"
289 echo "environment. If run in a terminal-only session, they will fail."
294 guess_merge_tool
() {
295 list_merge_tool_candidates
298 This message is displayed because '$TOOL_MODE.tool' is not configured.
299 See 'git ${TOOL_MODE}tool --tool-help' or 'git help config' for more details.
300 'git ${TOOL_MODE}tool' will now attempt to use one of the following tools:
304 # Loop over each candidate and stop when a valid merge tool is found.
307 is_available
"$tool" && echo "$tool" && return 0
310 echo >&2 "No known ${TOOL_MODE} tool is available."
314 get_configured_merge_tool
() {
315 # Diff mode first tries diff.tool and falls back to merge.tool.
316 # Merge mode only checks merge.tool
319 merge_tool
=$
(git config
diff.tool || git config merge.tool
)
321 merge_tool
=$
(git config merge.tool
)
323 if test -n "$merge_tool" && ! valid_tool
"$merge_tool"
325 echo >&2 "git config option $TOOL_MODE.tool set to unknown tool: $merge_tool"
326 echo >&2 "Resetting to default..."
332 get_merge_tool_path
() {
333 # A merge tool has been set, so verify that it's valid.
335 if ! valid_tool
"$merge_tool"
337 echo >&2 "Unknown merge tool $merge_tool"
342 merge_tool_path
=$
(git config difftool.
"$merge_tool".path ||
343 git config mergetool.
"$merge_tool".path
)
345 merge_tool_path
=$
(git config mergetool.
"$merge_tool".path
)
347 if test -z "$merge_tool_path"
349 merge_tool_path
=$
(translate_merge_tool_path
"$merge_tool")
351 if test -z "$(get_merge_tool_cmd "$merge_tool")" &&
352 ! type "$merge_tool_path" >/dev
/null
2>&1
354 echo >&2 "The $TOOL_MODE tool $merge_tool is not available as"\
358 echo "$merge_tool_path"
362 # Check if a merge tool has been configured
363 merge_tool
=$
(get_configured_merge_tool
)
364 # Try to guess an appropriate merge tool if no tool has been set.
365 if test -z "$merge_tool"
367 merge_tool
=$
(guess_merge_tool
) ||
exit